'From Pharo6.0 of 13 May 2016 [Latest update: #60527] on 12 December 2017 at 12:30:23.759644 am'!
TestCase subclass: #BittrexLibsodiumTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Bittrex'!

!BittrexLibsodiumTest methodsFor: 'tests-hmacsha512' stamp: 'BenComan 12/12/2017 00:08'!
test_RFC4231_case1
	"4.2 Test Case 1 (https://tools.ietf.org/html/rfc4231)"
	|data key output expected |
	key := (ByteArray readHexFrom: 
					'0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b',
					'0b0b0b0b') extendedToSize: 32.
   data := 'Hi There' .
	expected := ByteArray readHexFrom: 
					'87aa7cdea5ef619d4ff0b4241a1d6cb0',
					'2379f4e2ce4ec2787ad0b30545e17cde',
					'daa833b7d6b8a702038b274eaea3f4e4',
					'be9d914eeb61f1702e696c203a126854'.
   output := ByteArray new: 64.
	BittrexLibsodium crypto_auth_hmacsha512__out: output 
									in: data
									inlen: data size
									k: key.
	self assert: output equals: expected.! !

!BittrexLibsodiumTest methodsFor: 'tests-hmacsha512' stamp: 'BenComan 12/12/2017 00:17'!
test_RFC4231_case5
	"4.6 Test Case 5 (https://tools.ietf.org/html/rfc4231)"
	|data key output expected |
	key := (ByteArray readHexFrom: 
					'0c0c0c0c0c0c0c0c0c0c0c0c0c0c0c0c',
					'0c0c0c0c') extendedToSize: 32.
   data := (ByteArray readHexFrom: 
					'546573742057697468205472756e6361',
					'74696f6e').
	expected := ByteArray readHexFrom: 
					'415fad6271580a531d4179bc891d87a6'.
   output := ByteArray new: 64.
	BittrexLibsodium crypto_auth_hmacsha512__out: output 
									in: data
									inlen: data size
									k: key.
	self assert: (output first: expected size) equals: expected. ! !

!BittrexLibsodiumTest methodsFor: 'tests-hmacsha512' stamp: 'BenComan 12/11/2017 23:40'!
test1
	"4.2 (https://tools.ietf.org/html/rfc4231)"
	|data key expect a c result|
	key := 'Jefe' asByteArray , (ByteArray new: (32 - 'Jefe' size)).
   c := 'what do ya want for nothing?' asByteArray, (ByteArray new: 1).
   a := ByteArray new: 64.
	BittrexLibsodium crypto_auth_hmacsha512__out: a 
									in: c
									inlen: c size - 1 
									k: key.
	self halt.
	expect := ByteArray readHexFrom: 
					'87aa7cdea5ef619d4ff0b4241a1d6cb0',
					'2379f4e2ce4ec2787ad0b30545e17cde',
					'daa833b7d6b8a702038b274eaea3f4e4',
					'be9d914eeb61f1702e696c203a126854'.
	self 	assert: key size equals: 20.
	self 	assert: (BittrexLibsodium hmacSHA512data: data key: key)
			equals: expect.! !

!BittrexLibsodiumTest methodsFor: 'tests-hmacsha512' stamp: 'BenComan 12/12/2017 00:13'!
test_RFC4231_case4
	"4.5 Test Case 4 (https://tools.ietf.org/html/rfc4231)"
	|data key output expected |
	key := (ByteArray readHexFrom: 
					'0102030405060708090a0b0c0d0e0f10',
					'111213141516171819') extendedToSize: 32.
   data := (ByteArray readHexFrom: 
					'cdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd',
					'cdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd',
					'cdcdcdcdcdcdcdcdcdcdcdcdcdcdcdcd',
					'cdcd').
	expected := ByteArray readHexFrom: 
					'b0ba465637458c6990e5a8c5f61d4af7',
					'e576d97ff94b872de76f8050361ee3db',
					'a91ca5c11aa25eb4d679275cc5788063',
					'a5f19741120c4f2de2adebeb10a298dd'.
   output := ByteArray new: 64.
	BittrexLibsodium crypto_auth_hmacsha512__out: output 
									in: data
									inlen: data size
									k: key.
	self assert: output equals: expected.! !

!BittrexLibsodiumTest methodsFor: 'tests-hmacsha512' stamp: 'BenComan 12/12/2017 00:07'!
test_RFC4231_case2
	"4.3 Test Case 2 (https://tools.ietf.org/html/rfc4231)"
	|data key output expected |
	key := 'Jefe' asByteArray extendedToSize: 32.
   data := 'what do ya want for nothing?' .
	expected := ByteArray readHexFrom: 
					'164b7a7bfcf819e2e395fbe73b56e0a3',
					'87bd64222e831fd610270cd7ea250554',
					'9758bf75c05a994a6d034f65f8f0e6fd',
					'caeab1a34d4a6b4b636e070a38bce737'.
   output := ByteArray new: 64.
	BittrexLibsodium crypto_auth_hmacsha512__out: output 
									in: data
									inlen: data size
									k: key.
	self assert: output equals: expected.! !

!BittrexLibsodiumTest methodsFor: 'tests-hmacsha512' stamp: 'BenComan 12/12/2017 00:11'!
test_RFC4231_case3
	"4.4 Test Case 3 (https://tools.ietf.org/html/rfc4231)"
	|data key output expected |
	key := (ByteArray readHexFrom: 
					'aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa',
					'aaaaaaaa') extendedToSize: 32.
   data := (ByteArray readHexFrom: 
					'dddddddddddddddddddddddddddddddd',
					'dddddddddddddddddddddddddddddddd',
					'dddddddddddddddddddddddddddddddd',
					'dddd').
	expected := ByteArray readHexFrom: 
					'fa73b0089d56a284efb0f0756c890be9',
					'b1b5dbdd8ee81a3655f83e33b2279d39',
					'bf3e848279a722c806b485a47e67c807',
					'b946a337bee8942674278859e13292fb'.
   output := ByteArray new: 64.
	BittrexLibsodium crypto_auth_hmacsha512__out: output 
									in: data
									inlen: data size
									k: key.
	self assert: output equals: expected.! !
